﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using KS.CRM.PlugIn;
using KS.CRM.UI;

namespace HelloWorldPlugIn
{
    public class HelloWorldPlugInClass : KS.CRM.PlugIn.KSCRMPlugIn
    {        
        public override string Key
        {
            get
            {
                return "HelloWorld";
            }
        }

        public override string ParentKey
        {
            get
            {
                return "";
            }
        }

        public override string Title
        {
            get
            {
                return "Hello World Plug-In Sample";
            }
        }

        public override KS.CRM.PlugIn.CrmMainViewControlBase MainViewControl
        {
            get
            {
                return base.MainViewControlFactory<MainViewControl>();
            }
        }

        public override KS.CRM.PlugIn.CrmNavigationControlBase NavigationControl
        {
            get
            {
                return base.NavigationControlFactory<NavigationControl>();
            }
        }

        public override bool Connect(KS.CRM.Base.CrmDatabase DB)
        {
            this.m_DB = DB;

            NavigationControl.InitData(m_DB);
            MainViewControl.InitData(m_DB);

            NavigationControl.LoadData();
            MainViewControl.LoadData();            
            
            return true;
        }

        public override bool Disconnect(bool QueryCanDisconnect, bool Force)
        {
            NavigationControl.ResetData();
            NavigationControl.m_DB = null;
            

            MainViewControl.ResetData();
            MainViewControl.m_DB = null;
            
            this.m_DB = null;
            return true;
        }

        public override void Requery()
        {
            NavigationControl.RequeryData();
            MainViewControl.RequeryData();
        }

        public override bool Close()
        {
            MainViewControl.Close();
            NavigationControl.Close();
            return true;
        }

        public override System.Drawing.Image SmallIcon
        {
            get
            {
                // return a 16x16 image
                return Properties.Resources.plugin16;
            }
        }

        public override System.Drawing.Image LargeIcon
        {
            get
            {
                // return a 24x24 image
                return Properties.Resources.plugin24;
            }
        }        

        public override void LoadPlugIns(KS.CRM.Base.CrmDatabase DB)
        {
            NavigationControl.LoadPlugIns(DB);
            MainViewControl.LoadPlugIns(DB);
        }

        public override bool CanEditRecord(string PlugInKey)
        {
            return false;
        }

        public override bool CanSelectRecord(string PlugInKey)
        {
            return false;
        }

        public override KS.CRM.PlugIn.SelectRecordReturnResult SelectRecord(bool AllowNew, System.Windows.Forms.IWin32Window owner, params object[] parameters)
        {
            return null;
        }

        public override bool EditRecord(int ID, System.Windows.Forms.IWin32Window owner, bool CenterParent, params object[] parameters)
        {
            return false;
        }

        public override bool InvokeMethod(string Key, params object[] parameters)
        {
            return true;
        }

        public override object QueryProperty(string Key, params object[] parameters)
        {
            return null;
        }

        public override IKSCRMEditControl InfoControl
        {
            get
            {
                KS.CRM.UI.CrmInfoControlBase info = new InfoControl();
                info.InitPluginInfo(this);
                return info;
            }
        }

        public override IKSCRMEditControl SettingsControl
        {
	        get 
	        {
                KS.CRM.UI.CrmEditControlBase settings = new CrmEditControlBase();
                return settings;
	        }
        }

        public override string[] DependsOn()
        {
            // Test for Dependency
            //return new string[] {"Contacts 1.0.0"};

            return null;
        }

        public override string GetUpdateSql(string version)
        {
            if (version == "")
            {
                // Return a SQL query that creates your data tables on the connected database
                //return Properties.Resources.SQL_Create;
            }

            return String.Empty;
        }

        public override string GetUninstallSql()
        {
            // Return a SQL query that drops your data tables from the connected database
            //return Properties.Resources.SQL_Uninstall;
            return String.Empty;
        }
    }
}
